# automaticaly generated by xml2spec version 1.1

%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define base_name       oldtomcat
%define real_name       tomcat
%define full_name       jakarta-%{real_name}
%define major_version   3
%define name            %{base_name}%{major_version}
%define version         3.2.4
%define release         3
%define homedir         %{_var}/%{name}
%define instdir         %{_var}/%{name}
%define sconfdir        %{_sysconfdir}/%{name}/conf
%define confdir         %{homedir}/conf
%define appdir          %{homedir}/webapps
%define workdir         %{homedir}/work
%define logdir          %{homedir}/logs
%define libdir          %{homedir}/lib
%define packname        %{full_name}-%{version}-src
%define tcuid           95

Name:           %{name}
Version:        %{version}
Release:        %{release}jpp
Summary:        Apache Java servlet and JSP engine respecting 2.2/1.1 APIs
License:        Apache Software License
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        %{packname}.tar.gz
Source1:        %{name}-%{version}.init
Source2:        %{name}-%{version}.conf
Source3:        %{name}-%{version}.wrapper
Patch0:         %{name}-%{version}.patch.bz2
Url:            http://jakarta.apache.org/tomcat/
BuildRequires:  ant
BuildRequires:  servletapi3
BuildRequires:  jaxp_parser_impl
Group:          Development/Java
Buildarch:      noarch
Buildroot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Develop Web applications in Java using Servlet 2.2 and JSP 1.1 APIs
Nota that servlet engine %{version} is deprecated in favor of tomcat 3.3

%package javadoc
Group:          Development/Java
Summary:        Javadoc for %{name}
Requires:       %{name}

%description javadoc
Javadoc for %{name}.

%package webapps
Group:          System Environment/Applications
Summary:        Web Applications for %{name}
Requires:       %{name}

%description webapps
Web Applications for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n %{packname}
for i in src/shell/*.sh build.xml src/etc/*.xml; do
perl -pi -e "s|\015||g;" $i
done
%patch
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;

%build
export CLASSPATH=%{javadir}/jsse/jcert.jar:%{javadir}/jsse/jnet.jar:%{javadir}/jsse/jsse.jar
ant -Dtomcat.build=build -Dtomcat.dist=dist -Dant.jar=%{javadir}/ant.jar -Djaxp=%{javadir}/xml-commons-apis.jar -Dparser=%{javadir}/jaxp_parser_impl.jar -Dservlet.jar=%{javadir}/servletapi3.jar dist
    

%install
install -d -m 755 $RPM_BUILD_ROOT%{javadir}
install -d -m 755 $RPM_BUILD_ROOT%{javadocdir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{sconfdir}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{confdir}
mkdir -p ${RPM_BUILD_ROOT}%{appdir}
mkdir -p ${RPM_BUILD_ROOT}%{workdir}
mkdir -p ${RPM_BUILD_ROOT}%{libdir}
mkdir -p ${RPM_BUILD_ROOT}%{logdir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d
mv  dist/doc/javadoc/*          ${RPM_BUILD_ROOT}%{javadocdir}
cp -rf  dist/lib/*      ${RPM_BUILD_ROOT}%{libdir}
rm -f ${RPM_BUILD_ROOT}%{libdir}/jaxp_parser_impl.jar
rm -f ${RPM_BUILD_ROOT}%{libdir}/xml-commons-apis.jar
rm -f ${RPM_BUILD_ROOT}%{libdir}/ant.jar
rm -f ${RPM_BUILD_ROOT}%{libdir}/servlet.jar
install dist/conf/*         ${RPM_BUILD_ROOT}%{confdir}
install dist/webapps/*      ${RPM_BUILD_ROOT}%{appdir}
install dist/bin/jspc.sh    ${RPM_BUILD_ROOT}%{_bindir}/oldjspc3
install dist/bin/tomcat.sh  ${RPM_BUILD_ROOT}/usr/bin/d%{name}
install %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name}
install %{SOURCE2} ${RPM_BUILD_ROOT}/%{sconfdir}/%{name}.conf
install %{SOURCE3} $RPM_BUILD_ROOT/usr/bin/%{name}

     for i in ${RPM_BUILD_ROOT}/%{sconfdir}/%{name}.conf ${RPM_BUILD_ROOT}/usr/bin/d%{name} \
     ${RPM_BUILD_ROOT}/usr/bin/%{name} ${RPM_BUILD_ROOT}/usr/bin/oldjspc3 ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name} \
     ${RPM_BUILD_ROOT}/%{confdir}/server.xml; do
   	 perl -pi -e "s|\@\@\@PROCNAME\@\@\@|%{name}|g;" $i
   	 perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
   	 perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
   	 perl -pi -e "s|\@\@\@TCSCONF\@\@\@|%{sconfdir}|g;" $i
   	 perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
   	 perl -pi -e "s|\@\@\@TCINST\@\@\@|%{instdir}|g;" $i
   	 perl -pi -e "s|\@\@\@TCRUN\@\@\@|%{logdir}/%{name}.pid|g;" $i
   	 perl -pi -e "s|\@\@\@TCWORK\@\@\@|%{workdir}|g;" $i
     done
	
# jar versioning
for jar in $RPM_BUILD_ROOT%{javadir}/*-%{version}.jar; do
    (cd $RPM_BUILD_ROOT%{javadir} && ln -sf `basename $jar` `basename $jar -%{version}.jar`.jar)
done

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/useradd -c "Tomcat" -u %{tcuid} -s /bin/bash -r -d %{homedir} %{name} 2> /dev/null || : 

%post

	echo ""
	echo "Don't forget to setup vars in %{sconfdir}/%{name}.conf to"
	echo "adapt the RPM to your JDK for example."
	echo "As supplied we assume you're using IBM JDK 1.3.0"
	echo ""
	echo "For security purposes, %{name} is no more activated by"
	echo "default so don't forget to use chkconfig under root : "
	echo "/sbin/chkconfig --add %{name}"
	echo ""
	echo "as provided %{name} will run under user %{name}, uid %{tcuid}"
	echo "you could change it in %{sconfdir}/%{name}.conf and by chowning"
	echo "accordingly %{appdir}, %{confdir}, %{libdir}, %{logdir}, %{workdir}"

	if [ -f %{javadir}/servletapi3.jar ]; then
   		if [ ! -f %{libdir}/servlet.jar ]; then
       		ln -s %{javadir}/servletapi3.jar %{libdir}/servlet.jar
   		fi
	else
   		echo "missing %{javadir}/servletapi3.jar"
   		echo "make sure you have installed servlet3api package"
	fi

	if [ -f %{javadir}/ant.jar ]; then
   		if [ ! -f %{libdir}/ant.jar ]; then
   	    	ln -s %{javadir}/ant.jar %{libdir}/ant.jar
   		fi
	else
   		echo "missing %{javadir}/ant.jar"
   		echo "make sure you have installed ant package"
	fi

	if [ -f %{javadir}/xml-commons-apis.jar ]; then
   		if [ ! -f %{libdir}/xml-commons-apis.jar ]; then
       		ln -s %{javadir}/xml-commons-apis.jar %{libdir}/xml-commons-apis.jar
   		fi
	else
   		echo "missing %{javadir}/xml-commons-apis.jar"
   		echo "make sure you have installed xml-commons-apis package"
	fi

	if [ -f %{javadir}/jaxp_parser_impl.jar ]; then
   		if [ ! -f %{libdir}/jaxp_parser_impl.jar ]; then
       		ln -s %{javadir}/jaxp_parser_impl.jar %{libdir}/jaxp_parser_impl.jar
   		fi
	else
   		echo "missing %{javadir}/jaxp_parser_impl.jar"
   		echo "make sure you have installed a jaxp_parser_impl provider package"
	fi
	for i in jcert.jar jnet.jar jsse.jar; do
   		if [ -f %{javadir}/jsse/${i} ]; then
       		if [ ! %{libdir}/${i} ]; then
           		echo "auto installing JSSE ${i}"
           		ln -s  %{javadir}/jsse/${i} %{libdir}/${i}
       		fi
   		fi
	done

	chown -R %{name}:%{name} %{appdir}
	chown -R %{name}:%{name} %{confdir}
	chown -R %{name}:%{name} %{libdir}
	chown -R %{name}:%{name} %{logdir}
	chown -R %{name}:%{name} %{workdir}
	

%preun

	if [ $1 = 0 ]; then

   		if [ -f /var/lock/subsys/%{name} ]; then
   	 		/etc/rc.d/init.d/%{name} stop
   		fi
   		if [ -f /etc/rc.d/init.d/%{name} ]; then
   		 	/sbin/chkconfig --del %{name}
   		fi

   		/usr/sbin/userdel %{name}

   		rm -f %{libdir}/servlet.jar
   		rm -f  %{libdir}/jaxp_parser_impl.jar

   		for i in jcert.jar jnet.jar jsse.jar; do
       		rm -f  %{libdir}/${i}
   		done
	fi
	

%files
%defattr(-,root,root)
%dir                %{appdir}
%dir                %{workdir}
%dir                %{logdir}
%attr(644,root,root) %config(noreplace)     %{confdir}/*
%config             /etc/rc.d/init.d/%{name}
%config(noreplace)  %{sconfdir}/%{name}.conf
%{_bindir}
%{libdir}
%doc dist/doc/* LICENSE README RELE* TODO

%files javadoc
%defattr(-,root,root)
%{javadocdir}/%{name}

%post webapps
chown -R %{name}:%{name} %{appdir}

%files webapps
%defattr(644 root root 755)
%{appdir}

%changelog
* Fri Feb 28 2003 Henri Gomez <hgomez@users.sourceforge.net>  3.2.4-3jpp
- correct ASF license and add packager tag
- update to track changes in misc jars (xml, servletapi3, jsse...)

* Thu Dec 20 2001 Henri Gomez <hgomez@users.sourceforge.net> 3.2.4-2jpp
- fixed hardcoded ref to tomcat.conf

* Thu Dec 20 2001 Henri Gomez <hgomez@users.sourceforge.net> 3.2.4-1jpp
- 3.2.4
- renamed package to oldtomcat3
- all tomcat3 files/dirs renamed to oldtomcat3
- jspc3 renamed to oldjspc3

* Fri Nov 23 2001 Henri Gomez <hgomez@users.sourceforge.net> 3.2.4-1jpp
- 3.2.4
- use the xml2jpp framework
- major spec rewrite to meet JPackage requirements
- wrapper included to have tomcat running as %{name}
- config stuff add in %{sconfdir}/%{name}.conf to tune %{name} run mode
- all stuff installed under %{homedir} for now, TC 3.3 will be more FHS compliant
- servlet.jar is no more included but will be grabbed from servlet22 package
- ant.jar is no more included but will be grabbed from ant package
- jaxp parser jar is no more included but will be grabbed from jaxp_parser provider package
- JSSE jars are automatically installed if found under %{javadir}
- mix fixes, nota Tomcat 3.2.x is deprecated in favor of Tomcat 3.3
- built under Redhat 7.2 against JSSE 1.0.2


